#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

#include "canvas.h"

// les varialbes globales a ce module
unsigned char *pteur_video;

int           depth;
int           bpp;

GdkVisual     *visual;
// les palettes
unsigned short pal16[256];
unsigned int   pal32[256];



GtkWidget *create_canvas(int x_size,int y_size)
{
    GtkWidget *my_canvas;

        // on cree le canvas
    my_canvas=gtk_drawing_area_new();
        // on definit sa taille
    gtk_drawing_area_size(GTK_DRAWING_AREA(my_canvas), x_size, y_size);
    
    return my_canvas;
}

// Pour des raisons de bidouilles, on construit une image avec une ligne de plus
GdkImage    *create_image(int x_size,int y_size)
{
    GdkImage    *image;
    visual=gdk_visual_get_system();
    image=gdk_image_new(GDK_IMAGE_FASTEST,visual,x_size,y_size+1);
    pteur_video=(unsigned char*)image->mem;
    depth=visual->depth;
    bpp=image->bpp;
    return image;
}

// le visual doit etre initialise
// elle est donne de 0 63
void Inter_setCoul(int color,int r, int g, int b)
{
    if(depth==16)
    {
        pal16[color]=((r>>1)<<11)|(g<<5)|(b>>1);
    }
    if(depth==15)
    {
        pal16[color]=((r>>1)<<10)|((g>>1)<<5)|(b>>1);
    }
    else if(bpp==3)
    {
        pal32[color]=((r<<2)<<16)|((g<<2)<<8)|(b<<2);
        
    }
    else if(bpp==4)
    {
        pal32[color]=((r<<2)<<16)|((g<<2)<<8)|(b<<2);
        
    }
}

void Transfert_from_GB_to_Image_Double(unsigned char *gd_vid,int x_size,int y_size)
{
    int nb=x_size*y_size;
    int i,j;
        
    if((depth==16)||(depth==15)){
        unsigned short *pteur=(unsigned short*)pteur_video;
        unsigned char *offset=gd_vid;
        
        for(j=0;j<y_size;j++) {
            for(i=0;i<x_size;i++) {
                *(321+pteur)=*(320+pteur)=*(pteur+1)=*pteur=pal16[*offset++];
                pteur+=2;
            }
            offset+=256-x_size;
            pteur+=320;
        }
    }else if(bpp==3){
        unsigned char  *pteur=(unsigned char*)pteur_video;
        unsigned char *offset=gd_vid;
        
        for(j=0;j<y_size;j++){
            for(i=0;i<x_size;i++) {
                    *((int *)pteur)=pal32[*offset];
                    *((int *)(pteur+3))=pal32[*offset];
                    *((int *)(pteur+320*3))=pal32[*offset];
                    *((int *)(pteur+321*3))=pal32[*offset++];
                    pteur+=6;
            }
            offset+=256-x_size;
            pteur+=320*3;
        }
    }else if(bpp==4){
        unsigned int  *pteur=(unsigned int*)pteur_video;
        unsigned char *offset=gd_vid;
        
        for(j=0;j<y_size;j++){
            for(i=0;i<x_size;i++) {
                    *pteur=pal32[*offset];
                    *(pteur+1)=pal32[*offset];
                    *(pteur+320)=pal32[*offset];
                    *(pteur+321)=pal32[*offset++];
                    pteur+=2;
            }
            offset+=256-x_size;
            pteur+=320;
        }
    }else{
        g_print("only 15 & 16 & 24 &32 bits supported");
    }
    
    
}

void Transfert_from_GB_to_Image_Scanline(unsigned char *gd_vid,int x_size,int y_size)
{
    int nb=x_size*y_size;
    int i,j;

        
    if((depth==16)||(depth==15)){
        unsigned short *pteur=(unsigned short*)pteur_video;

        unsigned char *offset=gd_vid;
        
        for(j=0;j<y_size;j++) {
            for(i=0;i<x_size;i++) {
                *(pteur+1)=*pteur=pal16[*offset++];
                pteur+=2;
                
                
            }
            offset+=256-x_size;
            pteur+=320;
        }
        
    }else if(bpp==3){
        unsigned char  *pteur=(unsigned char*)pteur_video;
        unsigned char *offset=gd_vid;
        
        for(j=0;j<y_size;j++){
            for(i=0;i<x_size;i++) {
                *((int *)pteur)=pal32[*offset];
                pteur+=3;
                *((int *)pteur)=pal32[*offset++];
                pteur+=3;
            }
            offset+=256-x_size;
            pteur+=320*3;
        }
       
    }else if(bpp==4){
        unsigned int  *pteur=(unsigned int*)pteur_video;
        unsigned char *offset=gd_vid;
        
        for(j=0;j<y_size;j++){
            for(i=0;i<x_size;i++) {
                *pteur++=pal32[*offset];
                *pteur++=pal32[*offset++];
            }
            offset+=256-x_size;
            pteur+=320;
        }
       
    }else{
        g_print("only 15 & 16 & 24 & 32bits supported");
    }
    
    
}

void Transfert_from_GB_to_Image_Normal(unsigned char *gd_vid,int x_size,int y_size)
{
    int nb=x_size*y_size;
    int i,j;

        
    if((depth==16)||(depth==15)){
        unsigned short *pteur=(unsigned short*)pteur_video;
        unsigned char *offset=gd_vid;
        
        for(j=0;j<y_size;j++) {
            for(i=0;i<x_size;i++) {
                *pteur++=pal16[*offset++];
            }
            offset+=256-x_size;
            pteur+=160;
        }
        
    }else if(bpp==3){
        unsigned char  *pteur=(unsigned char*)pteur_video;
        unsigned char *offset=gd_vid;

        for(j=0;j<y_size;j++){
            for(i=0;i<x_size;i++) {
                *((int *)pteur)=pal32[*offset++];
                pteur+=3;
            }
            offset+=256-x_size;
            pteur+=160*3;
        }
    }else if(bpp==4){
        unsigned int  *pteur=(unsigned int*)pteur_video;
        unsigned char *offset=gd_vid;

        for(j=0;j<y_size;j++){
            for(i=0;i<x_size;i++) {
                *pteur=pal32[*offset++];
                pteur++;
            }
            offset+=256-x_size;
            pteur+=160;
        }   
        
    }else{
        g_print("only 15 & 16 & 24 & 32bits supported");
    }
}

void Clear_Image(int x_size,int y_size)
{
    int nb=x_size*y_size;
    int i;

        
    if((depth==16)||(depth==15)){
        unsigned short *pteur=(unsigned short*)pteur_video;

        memset(pteur,0,nb*sizeof(unsigned short));

    }else if(bpp==3){
         unsigned char *pteur=(unsigned char*)pteur_video;
         memset(pteur,0,nb*3);
    }else if(bpp==4){
         unsigned char *pteur=(unsigned char*)pteur_video;
         memset(pteur,0,nb*4);
    }else{
        g_print("only 15 & 16 & 24 & 32bits supported");
    }
    
    
}






