#ifndef __datas
#define __datas
#include <stdio.h>

// Choice of system: MSDOS, Linux, PowerPC, MacOS or UNix
//#define VER_MSDOS
//#define VER_LINUX
//#define VER_POWERPC
//#define VER_UNIX
//#define VER_MAC
#define VER_GTK

/* Global datas */

 

typedef struct REGSGB {
 word af ; 
 word bc ; 
 word de ; 
 word hl ; 
 word pc ; 
 word sp ; 
} REGISTRESGB ; 



// GAMEBOY Variables
#define VRAM    0x8000
#define OAM     0xFE00
#define JOYPAD  GBMemory [0xFF00]
#define SERIALD GBMemory [0xFF01]
#define SERIALC GBMemory [0xFF02]
#define DIVREG  GBMemory [0xFF04]
#define TIMECNT GBMemory [0xFF05]
#define TIMEMOD GBMemory [0xFF06]
#define TIMEFRQ GBMemory [0xFF07]
#define IFLAGS  GBMemory [0xFF0F]
#define LCDC    GBMemory [0xFF40]
#define STAT    GBMemory [0xFF41]
#define SCROLLY GBMemory [0xFF42]
#define SCROLLX GBMemory [0xFF43]
#define YCOORD  GBMemory [0xFF44]
#define YCMP    GBMemory [0xFF45]
#define BGPAL   GBMemory [0xFF47]
#define OBJPAL0 GBMemory [0xFF48]
#define OBJPAL1 GBMemory [0xFF49]
#define WINDOWY GBMemory [0xFF4A]
#define WINDOWX GBMemory [0xFF4B]
#define ISWITCH GBMemory [0xFFFF]

// Control Booleans
#define BGDisplay     ( LCDC&0x01 )                 // BG Display
#define SpriteDisplay ( LCDC&0x02 )                 // SPRITES Display
#define SpriteSize    ( ( LCDC&0x04 )?16:8 )          // SPRITES Size
#define BGTileMap     ( ( LCDC&0x08 )?0x9C00:0x9800 ) // BG Tile Map Location
#define TileData      ( ( LCDC&0x10 )?0x8000:0x8800 ) // Tile Data Location
#define WindowDisplay ( LCDC&0x20 )                 // WINDOW Display
#define WindowTileMap ( ( LCDC&0x40 )?0x9C00:0x9800 ) // WINDOW Tile Map Location
#define LCDCActive    ( LCDC&0x80 )                 // Display Enable

// Interrupt Flags
#define VBLANKflag   0x01
#define LCDCflag     0x02
#define TIMERflag    0x04
#define SERIALflag   0x08
#define JOYPADflag   0x10

// Interrupt Enables
#define VBLANKenable ( GBMemory [0xFFFF]&0x01 )
#define LCDCenable   ( GBMemory [0xFFFF]&0x02 )
#define TIMERenable  ( GBMemory [0xFFFF]&0x04 )
#define SERIALenable ( GBMemory [0xFFFF]&0x08 )
#define JOYPADenable ( GBMemory [0xFFFF]&0x10 )

// Definition of keyboard codes for DOS
// frEkidea: Use allegro codes, later with joystick
// GOLLUM-IDEA : Use variables with allegro codes to define any configuration
#ifdef VER_GTK
#define KEY_ESC K_ESC
#define KEY_UP  K_UP
#define KEY_DOWN K_DOWN
#define KEY_LEFT K_LEFT
#define KEY_RIGHT K_RIGHT
#define KEY_ENTER K_ENTER
#define KEY_TAB K_SPACE
#define KEY_CONTROL K_CTRL
#define KEY_ALT K_ALT
#endif

#define K_RESET        0x0E //BackSpace
#define K_SAVE_SCREEN  0x3C //F2 ( BMP FORMAT )
#define K_SAVE_SCREEN2 0x3D //F3 ( PCX FORMAT )
#define K_SAVE_SCREEN3 0x3E //F4 ( TGA FORMAT )
#define K_SAVE_SNAP    0x3F //F5
#define K_LOAD_SNAP    0x40 //F6
#define K_HALT         0x58 //F12 ( HALT EMULATION )
#define K_PAUSE        0x19 //P
#define K_ENTER        0x1C //Enter
#define K_SPACE        0x39 //Space
#define K_CTRL         0x1D //CTRL
#define K_ALT          0x38 //ALT
#define K_UP           0x48 //Up
#define K_DOWN         0x50 //Down
#define K_LEFT         0x4B //Left
#define K_RIGHT        0x4D //Right
#define K_ESC          0x01 //Escape

#define GB_UP     1
#define GB_DOWN   2
#define GB_LEFT   3
#define GB_RIGHT  4
#define GB_START  5
#define GB_SELECT 6
#define GB_A      7
#define GB_B      8



#endif
